from tkinter import *
from PIL import Image, ImageTk
import numpy as np
import random
import matplotlib.pyplot as plt

class Application:
    
    def __init__(self):

        self.anim=0
        self.viral=20
        self.period=7
        self.jour=0
        
        
        #creer la fenetre
        self.window = Tk()
        self.window.title("Automate cellulaire")
        self.window.geometry("1080x760")
        self.window.resizable(width=0, height=0)
        self.window.config(background='ivory')
        self.window.iconbitmap("Polytech_Angers.ico")

        #creer les frames
        self.frame1 = Frame(self.window,background='ivory')
        self.frame2 = Frame(self.window,background='ivory')

        #creer image
        self.img = Image.open("grille.png")
        self.image = ImageTk.PhotoImage(self.img.resize((700,760),4))
        self.canvas = Canvas(self.frame1,width=700,height=760,background='ivory')
        self.item = self.canvas.create_image(350,380,image=self.image)
        self.canvas.pack()

        self.canvas.bind("<Button-1>", self.click_gauche)
        
        #zone de texte
        self.label = Label(self.frame2,font = ('Sans','20','bold'),fg='#009CDD',background='ivory')
        self.label.configure(text = "Aucune simulation en cours")
        self.label.pack()

        self.label4 = Label(self.frame2,background='ivory')
        self.label4.configure(text = self.jour,font = ('Sans','20','bold'),fg='#009CDD')
        self.label4.pack()

        #creer les boutons
        self.bouton1=Button(self.frame2,text='Jeu de la vie',command=self.jeu_vie,height=2,width=25,fg='green',font = ('Sans','20','bold'),background='ivory').pack()
        self.bouton2=Button(self.frame2,text='Compteur de parité',command=self.compteur_parite,height=2,width=25,fg='green',font = ('Sans','20','bold'),background='ivory').pack()
        self.bouton12=Button(self.frame2,text='Règle de majorité',command=self.majorite,height=2,width=25,fg='green',font = ('Sans','20','bold'),background='ivory').pack()
        self.bouton5=Button(self.frame2,text='Pause',command=self.pause,height=2,width=25,fg='black',font = ('Sans','20','bold'),background='ivory').pack()
        self.bouton6=Button(self.frame2,text='Reset',command=self.reset,height=2,width=25,fg='red',font = ('Sans','20','bold'),background='ivory').pack()
        self.bouton4=Button(self.frame2,text='Cellules aléatoires', command=self.alea,height=2,width=25,fg='#FF6600',font = ('Sans','20','bold'),background='ivory').pack()
        self.bouton7=Button(self.frame2,text='Quitter',command=lambda :self.quitter(),height=2,width=25,fg='#004A75',font = ('Sans','20','bold'),background='ivory').pack(side=BOTTOM)

        #afficher les frames
        self.frame1.pack(side=LEFT)
        self.frame2.pack(side=RIGHT)

    def jeu_vie(self):
        if self.anim == 0 :
            self.anim = 1
            self.jour = 0
            self.poll()
            self.label.configure(text = "Simulation en cours: Jeu de la vie")
            
    def compteur_parite(self):
        if self.anim == 0 :
            self.anim = 2
            self.jour = 0
            self.poll()
            self.label.configure(text = "Simulation en cours: Compteur de parité")
        

    def majorite(self):
        if self.anim == 0 :
            self.anim = 3
            self.jour = 0
            self.poll()
            self.label.configure(text = "Simulation en cours: Regle de majorité")
            
    def poll (self) :
        if self.anim == 1:
            self.simu_jeu_vie()
            self.jour =self.jour+1
            self.label4.configure(text = self.jour)
            self.window.after(200,self.poll)
            
        if self.anim == 2:
            self.simu_compteur_parite()
            self.jour =self.jour+1
            self.label4.configure(text = self.jour)
            self.window.after(200,self.poll)

        if self.anim == 3:
            self.simu_majorite()
            self.jour =self.jour+1
            self.label4.configure(text = self.jour)
            self.window.after(200,self.poll)
            
            
    def pause(self):
        self.anim = 0
        self.label.configure(text = "Simulation en pause")
        
            
    def reset(self):
    	self.pause()
    	self.jour=0
    	self.label4.configure(text = self.jour)
    	self.img = Image.open("grille.png")
    	self.image = ImageTk.PhotoImage(self.img.resize((700,760),4))
    	self.item = self.canvas.create_image(350,380,image=self.image)
    	self.label.configure(text = "Grille remise à zéro")
        
    def simu_jeu_vie(self):
        #convertir en tableau
        self.imgnp = np.array(self.img)
        self.imgnp2 = np.copy(self.imgnp)
        
        #traiter image
        for i in range(self.imgnp.shape[0]):
            for j in range(self.imgnp.shape[1]):
                self.c=0
                if self.imgnp[i,j][0] == 255:
                    
                    if self.imgnp[i+1, j+1][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i-1, j-1][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i+1, j][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i-1, j][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i, j+1][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i, j-1][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i-1, j+1][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i+1, j-1][0] == 0:
                        self.c=self.c+1
                        
                    if self.c ==3:
                        self.imgnp2[i, j]=(0,0,0,255)

                self.c=0        
                if self.imgnp[i,j][0] == 0:

                    if self.imgnp[i+1, j+1][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i-1, j-1][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i+1, j][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i-1, j][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i, j+1][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i, j-1][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i-1, j+1][0] == 0:
                        self.c=self.c+1
                        
                    if self.imgnp[i+1, j-1][0] == 0:
                        self.c=self.c+1
                        
                    if self.c !=3 and self.c != 2:
                        self.imgnp2[i, j]=(255,255,255,255)
                        
        #convertir en image
        self.imgpil = Image.fromarray(self.imgnp2)
        self.img = self.imgpil
            
        #integrer l'imafe au canvas
        self.image = ImageTk.PhotoImage(self.imgpil.resize((700,760),4))
        self.item = self.canvas.create_image(350,380,image=self.image)

    def simu_compteur_parite(self):
        #convertir en tableau
        self.imgnp = np.array(self.img)
        self.imgnp2 = np.copy(self.imgnp)
        
        #traiter image
        for i in range(self.imgnp.shape[0]):
            for j in range(self.imgnp.shape[1]) :
                self.c=0
                
                if self.imgnp[i,j][0] == 255 or self.imgnp[i,j][0] == 0:

                	if self.imgnp[i+1, j+1][0] == 0:
                		self.c=self.c+1
                        
                	if self.imgnp[i-1, j-1][0] == 0:
                	    self.c=self.c+1
                        
               		if self.imgnp[i+1, j][0] == 0:
               			self.c=self.c+1
                        
               		if self.imgnp[i-1, j][0] == 0:
               			self.c=self.c+1
                      
                	if self.imgnp[i, j+1][0] == 0:
                		self.c=self.c+1
                        
                	if self.imgnp[i, j-1][0] == 0:
                		self.c=self.c+1
                        
                	if self.imgnp[i-1, j+1][0] == 0:
                		self.c=self.c+1
                        
                	if self.imgnp[i+1, j-1][0] == 0:
                		self.c=self.c+1
                        
                	if self.c%2 ==0:
                		self.imgnp2[i, j]=(255,255,255,255)
                	else:
               	 		self.imgnp2[i, j]=(0,0,0,255)
                        
        #convertir en image
        self.imgpil = Image.fromarray(self.imgnp2)
        self.img = self.imgpil
            
        #integrer l'imafe au canvas
        self.image = ImageTk.PhotoImage(self.imgpil.resize((700,760),4))
        self.item = self.canvas.create_image(350,380,image=self.image)

    def simu_majorite(self):
        #convertir en tableau
        self.imgnp = np.array(self.img)
        self.imgnp2 = np.copy(self.imgnp)
        
        #traiter image
        for i in range(self.imgnp.shape[0]):
            for j in range(self.imgnp.shape[1]):
                self.c=0
                    
                if self.imgnp[i,j][0] == 255 or self.imgnp[i,j][0] == 0:
                	if self.imgnp[i+1, j+1][0] == 255:
                		self.c=self.c+1
                        
                	if self.imgnp[i-1, j-1][0] == 255:
                		self.c=self.c+1
                        
               		if self.imgnp[i+1, j][0] == 255:
               			self.c=self.c+1
                        
               		if self.imgnp[i-1, j][0] == 255:
               			self.c=self.c+1
                      
                	if self.imgnp[i, j+1][0] == 255:
                		self.c=self.c+1
                        
                	if self.imgnp[i, j-1][0] == 255:
                		self.c=self.c+1
                        
                	if self.imgnp[i-1, j+1][0] == 255:
                		self.c=self.c+1
                        
                	if self.imgnp[i+1, j-1][0] == 255:
                		self.c=self.c+1
                        
                	if self.c>4:
                		self.imgnp2[i, j]=(255,255,255,255)
                	if self.c<4:
                		self.imgnp2[i, j]=(0,0,0,255)
                        
        #convertir en image
        self.imgpil = Image.fromarray(self.imgnp2)
        self.img = self.imgpil
            
        #integrer l'imafe au canvas
        self.image = ImageTk.PhotoImage(self.imgpil.resize((700,760),4))
        self.item = self.canvas.create_image(350,380,image=self.image)

    def click_gauche(self,evt):
        #convertir en tableau
        self.imgnp = np.array(self.img)
        self.imgnp2 = np.copy(self.imgnp)
        
        #traiter image
        if self.imgnp[evt.y//10,evt.x//10][0] == 255:
            self.imgnp2[evt.y//10,evt.x//10] = (0,0,0,255)
            
        if self.imgnp[evt.y//10,evt.x//10][0] == 0:
            self.imgnp2[evt.y//10,evt.x//10] = (255,255,255,255)
        
        #convertir en image
        self.imgpil = Image.fromarray(self.imgnp2)
        self.img = self.imgpil
            
        #integrer l'imafe au canvas
        self.image = ImageTk.PhotoImage(self.imgpil.resize((700,760),4))
        self.item = self.canvas.create_image(350,380,image=self.image)

    def alea(self):
    	self.reset()
    	#convertir en tableau
    	self.imgnp = np.array(self.img)
    	self.imgnp2 = np.copy(self.imgnp)

    	#traiter image
    	for i in range(self.imgnp.shape[0]):
    		for j in range(self.imgnp.shape[1]):
    			if self.imgnp[i,j][0] == 255:
    				if random.randint(1,2)==1:
    					self.imgnp2[i, j]=(0,0,0,255)

    	#convertir en image
    	self.imgpil = Image.fromarray(self.imgnp2)
    	self.img = self.imgpil

    	#integrer l'imafe au canvas
    	self.image = ImageTk.PhotoImage(self.imgpil.resize((700,760),4))
    	self.item = self.canvas.create_image(350,380,image=self.image)

    def quitter(self):
    	self.window.destroy()



    
        
if __name__ == "__main__":
    app=Application()
    app.window.mainloop()
    

